| Правила | Регистрация | Пользователи | Поиск | Сообщения за день | Все разделы прочитаны |  Справка по форуму | Файлообменник |

Вернуться   Форум DWG.RU > Программное обеспечение > AutoCAD > Динамические блоки > Как не поворачивать текст при "глобальном" повороте динамического блока?

Как не поворачивать текст при "глобальном" повороте динамического блока?

Ответ
Поиск в этой теме
Непрочитано 07.04.2020, 12:55 #1
Как не поворачивать текст при "глобальном" повороте динамического блока?
Tregart
 
Регистрация: 10.04.2011
Сообщений: 250

Здравствуйте!
Есть динамический блок в котором нельзя использовать параметр поворота, поворачивать блок можно только командой "повернуть" из пространства модели. И в нем есть атрибут (номер блока), который поворачивать не нужно. Есть ли какие-то способы прибить этот текст горизонтально? Попробовал добавить зависимость "горизонтальность", но она не работает, - текст все равно поворачивается вместе с блоком. Как решить такую задачу?

Вложения
Тип файла: dwg
DWG 2010
динамический блок.dwg (80.3 Кб, 51 просмотров)

Просмотров: 5144
 
Непрочитано 07.04.2020, 13:16
#2
engngr

сети
 
Регистрация: 03.11.2008
Московия*
Сообщений: 5,749


(Аннотативный) текстовый с всегда горизонтальным положением?
engngr вне форума  
 
Автор темы   Непрочитано 07.04.2020, 13:21
#3
Tregart


 
Регистрация: 10.04.2011
Сообщений: 250


Не понял о чём вы. Где задать это "всегда горизонтальное положение"? Ни в свойствах атрибута, ни в свойствах блока этого нет. Попробовал сделать в текстовом стиле "ориентация по листу текста" - не помогло.
Tregart вне форума  
 
Непрочитано 07.04.2020, 13:41
#4
AlexCondor

инженер
 
Регистрация: 03.08.2007
Сообщений: 1,321


КМК, такой возможности в AutoCAD'е нет. Но, после поворота можно вернуть атрибут в 0, например, использовав макрос: ^C^C-attedit;_yes;*;*;*;\;_angle;0;;
AlexCondor вне форума  
 
Автор темы   Непрочитано 07.04.2020, 13:57
#5
Tregart


 
Регистрация: 10.04.2011
Сообщений: 250


Цитата:
Сообщение от AlexCondor Посмотреть сообщение
КМК, такой возможности в AutoCAD'е нет. Но, после поворота можно вернуть атрибут в 0, например, использовав макрос: ^C^C-attedit;_yes;*;*;*;\;_angle;0;;
А как это сделать, не подскажете?
Tregart вне форума  
 
Непрочитано 07.04.2020, 14:06
1 | #6
AlexCondor

инженер
 
Регистрация: 03.08.2007
Сообщений: 1,321


Ну можно повесить этот макрос на кнопку или создать команду. Или попросту ввести команду -attedit и последовательно ответить на все запросы.
AlexCondor вне форума  
 
Автор темы   Непрочитано 07.04.2020, 14:08
#7
Tregart


 
Регистрация: 10.04.2011
Сообщений: 250


Спасибо, буду разбираться.
Tregart вне форума  
 
Непрочитано 07.04.2020, 14:10
#8
AlexCondor

инженер
 
Регистрация: 03.08.2007
Сообщений: 1,321


Есть еще вариант. См. здесь файл example.dwg. Но текст там не входит в состав блока.
AlexCondor вне форума  
 
Непрочитано 07.04.2020, 20:39
#9
doctorraz

электрик
 
Регистрация: 19.02.2010
Волгоград
Сообщений: 2,256
Отправить сообщение для doctorraz с помощью Skype™


Цитата:
Сообщение от Tregart Посмотреть сообщение
Где задать это "всегда горизонтальное положение"?
в стиле текста, задать анотативность, обновить атрибуты
__________________
Мастерская СПДС
doctorraz вне форума  
 
Автор темы   Непрочитано 09.04.2020, 20:30
#10
Tregart


 
Регистрация: 10.04.2011
Сообщений: 250


Цитата:
Сообщение от AlexCondor Посмотреть сообщение
Есть еще вариант. См. здесь файл example.dwg. Но текст там не входит в состав блока.
Не, так не пойдет.

----- добавлено через 19 сек. -----
Цитата:
Сообщение от doctorraz Посмотреть сообщение
в стиле текста, задать анотативность, обновить атрибуты
не помогло, всё равно вращается.
Tregart вне форума  
 
Непрочитано 10.04.2020, 08:23
#11
doctorraz

электрик
 
Регистрация: 19.02.2010
Волгоград
Сообщений: 2,256
Отправить сообщение для doctorraz с помощью Skype™


Цитата:
Сообщение от Tregart Посмотреть сообщение
не помогло, всё равно вращается.
да ладно
Вложения
Тип файла: dwg
DWG 2010
Контакты НЗ с замедлением.dwg (71.5 Кб, 79 просмотров)
__________________
Мастерская СПДС
doctorraz вне форума  
 
Непрочитано 10.04.2020, 09:52
#12
engngr

сети
 
Регистрация: 03.11.2008
Московия*
Сообщений: 5,749


Интерсно. У меня на ac2016 так: если блок аннотативный - сохраниение ориентации не работает (и атриубты становятся неаннотативными). Причем если ранее неаннотативному блоку задать аннотативность, то аттрибут перестаёт сохранять ориентацию по листу, и смена аннотативности блока на нет не возвращает это свойство.
То есть для сохранения ориентации по листу аттрибут должен быть создан аннотативным и в неаннотативном блоке.
engngr вне форума  
 
Непрочитано 10.04.2020, 10:17
#13
doctorraz

электрик
 
Регистрация: 19.02.2010
Волгоград
Сообщений: 2,256
Отправить сообщение для doctorraz с помощью Skype™


можно так.
Код:
[Выделить все]
 
(defun C:А0 (/ *error* ocmde)
  (defun *error* (msg) (setvar 'cmdecho ocmde) (princ))
  (setq ocmde (getvar 'cmdecho))
  (setvar 'cmdecho 0)
  (prompt "\nТкни атрибут: ")
  (command "_-attedit" "_y" "*" "*" "*" pause "" "_a" "0" "")
  (C:А0)
) ;_ end defun
__________________
Мастерская СПДС
doctorraz вне форума  
 
Непрочитано 12.04.2020, 19:35
#14
Сергей812


 
Регистрация: 10.08.2013
Сообщений: 10,927


сам атрибут повесить на операцию поворота, скрыть у операции поворота ручки и показ в свойствах. Затем операции поворота присваивать программно угол поворота вставки блока с обратным знаком - и вуаля: видимой операции поворота нет, а атрибут все в том же месте. Но тут есть и большой минус - надо фиксировать определение атрибута, чтобы была возможность добавить в операцию поворота. А чем вызваны эти титанические усилия по неиспользованию именно операции динповорота, а не запрета динблоков в целом?
Сергей812 вне форума  
 
Непрочитано 03.05.2023, 07:08
#15
MrBrown

ПенсионЭр
 
Регистрация: 26.06.2009
Сообщений: 359


Здравствуйте!
Недавно столкнулся с той же проблемой: хочется, чтобы при повороте блока текст оставался бы привязанным к блоку в той же точке, но не поворачивался.
Приложил файл "Как есть - как надо". Здесь дин. блок с ручками поворота конструкции и текста.
Пока выхожу из положения так: после поворота дин. блока возвращаю текст в горизонтальное состояние за ручку поворота текста.
Кто-нибудь знает, как уменьшить количество операций поворота дин. блока?
Спасибо.
Вложения
Тип файла: dwg
DWG 2007
Дин.блок.dwg (91.2 Кб, 29 просмотров)
MrBrown вне форума  
 
Непрочитано 03.05.2023, 10:04
1 | #16
AlexCondor

инженер
 
Регистрация: 03.08.2007
Сообщений: 1,321


MrBrown, Что-то типа этого?
Вложения
Тип файла: dwg
DWG 2007
Дин.блок 2.dwg (96.2 Кб, 76 просмотров)
AlexCondor вне форума  
 
Непрочитано 03.05.2023, 10:48
#17
MrBrown

ПенсионЭр
 
Регистрация: 26.06.2009
Сообщений: 359


AlexCondor, не "типа", а точно так!
Пожалуйста, опишите, что Вы сделали, так как подобное нужно включить в другие разные блоки.
Большое спасибо!
MrBrown вне форума  
 
Непрочитано 03.05.2023, 11:28
2 | #18
name02


 
Регистрация: 10.01.2020
Сообщений: 167


Это называется цепочка операций.
Для параметра перемещения в свойствах поставить "Да" для цепочки операций.
А сам параметр включить в действие поворота параметра поворота.
Суть в том, что действие поворота будет "тянуть" (поворачивать) за собой параметр перемещения. Соответственно и действие перемещения тоже будет выполняться.
name02 вне форума  
 
Непрочитано 03.05.2023, 11:47
#19
MrBrown

ПенсионЭр
 
Регистрация: 26.06.2009
Сообщений: 359


name02, С цепочкой операций я немного продвинулся: Мтекст не вращается с вращением угла. Но он (Мтекст) и не следует за углом, остаётся на месте.
Что-то делаю не так.
MrBrown вне форума  
 
Непрочитано 03.05.2023, 11:59
#20
MrBrown

ПенсионЭр
 
Регистрация: 26.06.2009
Сообщений: 359


Вот что получилось (см. вложение)
Вложения
Тип файла: dwg
DWG 2007
Дин.блок 3.dwg (103.4 Кб, 50 просмотров)

Последний раз редактировалось MrBrown, 03.05.2023 в 12:17.
MrBrown вне форума  
 
Непрочитано 03.05.2023, 12:04
1 | #21
Demonakor


 
Регистрация: 28.11.2022
Сообщений: 66


В исходном варианте операция точечного перемещения не работала. Её можно было удалить, и ничего бы не поменялось, потому что текст вращался операцией поворота.
Но чтобы он оставался горизонтальным - его нужно только перемещать точечным перемещением с включённой цепочкой операций. То есть точечное перемещение вращать нужно, а текст из операции вращения исключить.

PS: в последнем варианте не хватает операции перемещения.
Demonakor вне форума  
 
Непрочитано 03.05.2023, 12:07
1 | #22
AlexCondor

инженер
 
Регистрация: 03.08.2007
Сообщений: 1,321


В операцию вращения добавляется точка ("Положение1"). А уже к этой точке добавляется операция перемещения для объекта текст. В свойствах точки включаем опцию "цепочка операций".
И теперь привязка текста просто должна следовать за расположением точки положения.
AlexCondor вне форума  
 
Непрочитано 03.05.2023, 12:16
#23
MrBrown

ПенсионЭр
 
Регистрация: 26.06.2009
Сообщений: 359


Demonakor, AlexCondor, спасибо большое! Пока я разбирался сам, вы тоже мне написали.
Всё получилось.
MrBrown вне форума  
 
Непрочитано 03.05.2023, 12:48
1 | #24
name02


 
Регистрация: 10.01.2020
Сообщений: 167


У тебя параметр перемещения не имеет никаких действий - добавь действие перемещения и включи в него твой текст.
name02 вне форума  
 
Непрочитано 03.05.2023, 14:12
#25
MrBrown

ПенсионЭр
 
Регистрация: 26.06.2009
Сообщений: 359


name02, Да, я это понял. Мой недосмотр.
Спасибо!
MrBrown вне форума  
Ответ
Вернуться   Форум DWG.RU > Программное обеспечение > AutoCAD > Динамические блоки > Как не поворачивать текст при "глобальном" повороте динамического блока?

Размещение рекламы
Опции темы Поиск в этой теме
Поиск в этой теме:

Расширенный поиск


Похожие темы
Тема Автор Раздел Ответов Последнее сообщение
Изменение атрибутов динамического блока сразу на нескольких листах в файле чертежа Builder_Drew Динамические блоки 34 13.12.2022 17:15
VBA. Как в AutoCad создать всплывающее диалоговое окно, которое будет запрашивать свойства динамического блока перед его вставкой Jeneva Программирование 9 23.06.2017 19:28
Нужна помощь при вставке динамического блока [email protected] LISP 4 17.06.2016 10:53
Атрибут аннотативного динамического блока sergeev_2005 Динамические блоки 15 17.02.2015 15:00
Установка параметров динамического блока в VBA тормозит bars4 Программирование 4 01.10.2012 10:27